#include "sngbeta.inc"
 .ORG START_ADDR
 .DB "Mario SNG v0.1",0

;adresse de routines modifies dans SNG:
graysprite_plane_0 = $8EC5
graysprite_plane_1 = $8ED6
grayscale_colonne  = $93FD
long_sprite_affich = $8FE7

debut:
;Affiche le titre
 LD HL,titre
 LD DE,PLANE_0
 LD BC,768            
 LDIR
 LD HL,titre2
 LD DE,PLANE_1
 LD BC,768            
 LDIR

;Affiche le menu
 SET 7,(IY+$14);Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD
 PRINTM($2037,jouer)
 PRINTM($2832,A_propos)
 PRINTM($3034,Quitter)
 LD B,24
 LD C,0
noirci_les_lettres:
 PUSH BC
 LD H,0
 LD L,B
 LD BC,12
 CALL MUL_HL_BC
 PUSH HL
 LD BC,PLANE_1+384+6
 ADD HL,BC
 EX DE,HL
 POP HL
 LD BC,PLANE_0+384+6
 ADD HL,BC
 LD BC,4
 LDIR
 POP BC
 DJNZ noirci_les_lettres
 LD A,0
 LD (sprite_champignon),A
 call affiche_sprite_champignon
 CALL GRAYSCALE_ON
 call touches_menu
quit:
 CALL GRAYSCALE_OFF
 RET

pause_clear:
 ld a,$FF
 out (1),a
 ld a,$FD
 out (1),a
 in a,(1)
 and %01000000
 jr nz,pause_clear
 RET

touches_menu:
 ld a,%11111110
 out (1),a
 in a,(1)
 and %00001000
 call z,haut
 ld a,%11111110
 out (1),a
 in a,(1)
 and %00000001
 call z,bas
 ld a,$FF
 out (1),a
 ld a,%11111101
 out (1),a
 in a,(1)
 and %00000001
 jp z,enter
 JR touches_menu

enter:
 LD A,(sprite_champignon)
 CP 0
 JR Z,jouer_select
 CP 1
 JR Z,apropos_select
 RET
jouer_select:
 POP HL
 LD HL,jouer_menu
 PUSH HL
 RET
apropos_select:
 POP HL
 LD HL,A_propos_menu
 PUSH HL
 RET

haut:
 IN A,(1)
 AND %00001000
 JR Z,haut
 call efface_sprite_champignon
 LD A,(sprite_champignon)
 CP 0
 JR Z,trophaut
 DEC A
 JR haut1
trophaut:
 LD A,2
haut1:
 LD (sprite_champignon),A
 call affiche_sprite_champignon
 ret

bas:
 IN A,(1)
 AND %00000001
 JR Z,bas
 call efface_sprite_champignon
 LD A,(sprite_champignon)
 CP 2
 JR Z,tropbas
 INC A
 JR bas1
tropbas:
 LD A,0
bas1:
 LD (sprite_champignon),A
 call affiche_sprite_champignon
 ret

affiche_sprite_champignon:
 LD A,(sprite_champignon)
 CP 1
 JR Z,sprite_champignon1
 CP 2
 JR Z,sprite_champignon2
;sprite_champignon0:
 LD BC,$2D20 ;B=X C=Y
 JR affiche_sprite_champignon_plan0
sprite_champignon1:
 LD BC,$2828 ;B=X C=Y
 JR affiche_sprite_champignon_plan0
sprite_champignon2:
 LD BC,$2A30 ;B=X C=Y
affiche_sprite_champignon_plan0:
 LD DE,s63   ;adresse
 LD A,8      ;taille
 CALL GRAYSPRITE
 LD A,(sprite_champignon)
 CP 1
 JR Z,sprite_champignon1_1
 CP 2
 JR Z,sprite_champignon2_1
;sprite_champignon0_1:
 LD BC,$4C20 ;B=X C=Y
 JR affiche_sprite_champignon_plan1
sprite_champignon1_1:
 LD BC,$5028 ;B=X C=Y
 JR affiche_sprite_champignon_plan1
sprite_champignon2_1:
 LD BC,$4E30 ;B=X C=Y
affiche_sprite_champignon_plan1:
 LD DE,s63   ;adresse
 LD A,8      ;taille
 CALL GRAYSPRITE
 RET

efface_sprite_champignon:
 LD A,(sprite_champignon)
 CP 1
 JR Z,sprite_champignon1_2
 CP 2
 JR Z,sprite_champignon2_2
;sprite_champignon0_2:
 LD BC,$2D20 ;B=X C=Y
 JR efface_sprite_champignon_plan0
sprite_champignon1_2:
 LD BC,$2828 ;B=X C=Y
 JR efface_sprite_champignon_plan0
sprite_champignon2_2:
 LD BC,$2A30 ;B=X C=Y
efface_sprite_champignon_plan0:
 LD DE,s63   ;adresse
 LD A,8      ;taille
 CALL GRAYREMOVE_SPRITE
 LD A,(sprite_champignon)
 CP 1
 JR Z,sprite_champignon1_1_2
 CP 2
 JR Z,sprite_champignon2_1_2
;sprite_champignon0_1_2:
 LD BC,$4C20 ;B=X C=Y
 JR efface_sprite_champignon_plan1
sprite_champignon1_1_2:
 LD BC,$5028 ;B=X C=Y
 JR efface_sprite_champignon_plan1
sprite_champignon2_1_2:
 LD BC,$4E30 ;B=X C=Y
efface_sprite_champignon_plan1:
 LD DE,s63   ;adresse
 LD A,8      ;taille
 CALL GRAYREMOVE_SPRITE
 RET

A_propos_menu:
 CALL GRAYSCALE_OFF
 ROM_CALL(CLEARLCD)
 RES 7,(IY+$14)
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,apropos_ch
 ROM_CALL(D_ZT_STR)
 LD HL,$3000
 LD (GRAF_CURS),HL
 LD HL,apropos_ch2
 ROM_CALL(D_ZM_STR)
 call pause_clear
 JP debut

jouer_menu:
;menu pour selectionner le niveau
 CALL CLR_BUF
 SET 3,(IY+$05) ; Fait en sorte que le texte soit affich blanc sur noir 
 PRINTM(0,choisissez_niv)
 LD	HL,PLANE_0
 LD	DE,PLANE_1
 LD	BC,72
 LDIR
 LD	HL,PLANE_0+72
 LD	DE,PLANE_0+73
 LD	(HL),$FF
 LD	BC,10
 LDIR
 LD A,%11111110
 LD (DE),A
 LD	HL,PLANE_1+72
 LD	DE,PLANE_1+73
 LD	(HL),$FF
 LD	BC,10
 LDIR
 LD A,%11111110
 LD (DE),A
 RES 3,(IY+$05) ; Fait en sorte que le texte soit affich noir sur blanc

;Cette routine va chercher les diffrents niveaux et va les afficher.
 LD HL,$FD9E
 LD A,0
 LD (nombre_de_niveaux),A
cherche_niv:
 DEC HL
 LD A,(HL)
 CP 6
 JR NZ,p_est_ce_un_niveau
 PUSH HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 INC HL
 INC HL
 LD A,(HL)
 CP $AA
 JR NZ,c_pas_un_niv
 INC HL
 LD A,(HL)
 CP $BB
 JR NZ,c_pas_un_niv
;ici, on est sur que c'est un niveau
 INC HL
 LD	DE,TEXT_MEM
 LD	BC,24
 LDIR
 LD A,0
 LD (DE),A
 LD A,(nombre_de_niveaux)
 INC A
 LD (nombre_de_niveaux),A
 LD H,0
 LD L,A
 LD BC,6
 CALL MUL_HL_BC
 INC HL
 LD H,L
 LD L,0
 LD (GRAF_CURS),HL
 LD HL,TEXT_MEM
 ROM_CALL(D_ZM_STR)
c_pas_un_niv:
 POP HL
p_est_ce_un_niveau:
 LD DE,($8D18)
 CALL CP_HL_DE
 JR NZ,cherche_niv

 LD A,(nombre_de_niveaux)
 OR 0
 JP Z,quit_menu

 LD A,0
 LD (niveau_choisi),A
 call noirci_nom_du_niv

touches_select_niv:
 ld a,$FF
 out (1),a
 ld a,$FD
 out (1),a
 in a,(1)
 and %01000000
 jr z,quit_menu
 ld a,%11111110
 out (1),a
 in a,(1)
 and %00001000
 call z,haut_niv
 ld a,%11111110
 out (1),a
 in a,(1)
 and %00000001
 call z,bas_niv
 ld a,$FF
 out (1),a
 ld a,%11111101
 out (1),a
 in a,(1)
 and %00000001
 jp z,enter_niv
 JR touches_select_niv

quit_menu:
 CALL GRAYSCALE_OFF
 JP debut

enter_niv:
 CALL GRAYSCALE_OFF
 JP prepare_monde

haut_niv:
 IN A,(1)
 AND %00001000
 JR Z,haut_niv
 LD A,(niveau_choisi)
 CP 0
 RET Z
 call eclairci_nom_du_niv
 LD A,(niveau_choisi)
 DEC A
 LD (niveau_choisi),A
 call noirci_nom_du_niv
 ret

bas_niv:
 IN A,(1)
 AND %00000001
 JR Z,bas_niv
 LD A,(nombre_de_niveaux)
 LD B,A
 DEC B
 LD A,(niveau_choisi)
 CP B
 RET Z
 call eclairci_nom_du_niv
 LD A,(niveau_choisi)
 INC A
 LD (niveau_choisi),A
 call noirci_nom_du_niv
 ret

noirci_nom_du_niv: ;A=numro de la chaine  noircir
 LD H,0
 LD L,A
 LD BC,72
 CALL MUL_HL_BC
 LD BC,84
 ADD HL,BC
 PUSH HL
 LD BC,PLANE_1
 ADD HL,BC
 EX DE,HL
 POP HL
 LD BC,PLANE_0
 ADD HL,BC
 LD	BC,72
 LDIR
 RET

eclairci_nom_du_niv: ;A=numro de la chaine  noircir
 LD H,0
 LD L,A
 LD BC,72
 CALL MUL_HL_BC
 LD BC,84
 ADD HL,BC
 LD BC,PLANE_1
 ADD HL,BC
 LD D,H
 LD E,L
 INC DE
 LD	(HL),0
 LD	BC,72
 LDIR
 RET

;dcompresse le monde
prepare_monde:
 LD A,1
 LD (level),A
prepare_monde2:
;cherche l'adresse du monde (octet juste aprs le mot de passe)
 LD HL,$FD9E
 LD A,0
 LD (buffer8),A
cherche_adresse_niv:
 DEC HL
 LD A,(HL)
 CP 6
 JR NZ,p_est_ce_un_niveau2
 PUSH HL
 DEC HL
 LD E,(HL)
 DEC HL
 LD D,(HL)
 EX DE,HL
 INC HL
 INC HL
 LD A,(HL)
 CP $AA
 JR NZ,c_pas_un_niv2
 INC HL
 LD A,(HL)
 CP $BB
 JR NZ,c_pas_un_niv2
;ici, on est sur que c'est un niveau
 INC HL
 LD	DE,TEXT_MEM
 LD	BC,24
 LDIR
 LD BC,4
 ADD HL,BC
 LD (adresse_du_niveau),HL
 LD A,0
 LD (DE),A
 LD A,(niveau_choisi)
 LD B,A
 LD A,(buffer8)
 CP B
 JR z,c_le_bon_niv
 INC A
 LD (buffer8),A
 LD H,0
 LD L,A
 LD BC,6
 CALL MUL_HL_BC
 INC HL
 LD H,L
 LD L,0
 LD (GRAF_CURS),HL
 LD HL,TEXT_MEM
 ROM_CALL(D_ZM_STR)
c_pas_un_niv2:
 POP HL
p_est_ce_un_niveau2:
 LD DE,($8D18)
 CALL CP_HL_DE
 JR NZ,cherche_adresse_niv
c_le_bon_niv:
 POP HL
 call Charge_niv
 call range_CurEnemyTable

 LD HL,ennemis_affiches
 LD (pointeur_ennemis_affiches),HL
 LD DE,ennemis_affiches+1
 LD (HL),0
 LD BC,225
 LDIR
 LD HL,CurEnemyTable+1
 LD (cherche_colonne-2),HL

 call GRAYSCALE_ON
 call affiche_niveau_1ere_fois
 LD A,8
 LD (num_colonneb-1),A
 LD A,3
 LD (buffer8),A

 LD A,$2B-1                 ;Modifie la routine de SNG
 LD (grayscale_colonne),A   ;N'affiche pas les 2 dernires colonnes

 call affiche_menu_gauche

 LD DE,buffer_ecr
 CALL sauve_ecran

 XOR A
 LD (sprite_mar_aff),A
 LD (saut),A
 LD A,0
 LD (x_mario),A
 LD A,0
 LD (y_mario),A
 LD DE,mario_petit_arret_0
 call place_mario

 LD HL,buffer_ecr_PLANE_0   ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,buffer_ecr_PLANE_1   ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;

 LD A,3
 LD (vies),A
 XOR A
 LD (mario_transformation),A ;Mario est petit
 LD (pieces),A
 RES 7,(IY+$14) ;Ecrit du texte de menu sur l'cran LCD seulement et pas dans la mmoire de texte (GRAPH_MEM) 
 LD HL,$0953\ LD (GRAF_CURS),HL\ LD H,0\ LD A,(vies)\ LD L,A\ CALL HL_DECI\ ROM_CALL(D_ZM_STR)
 LD HL,$2053\ LD (GRAF_CURS),HL\ LD H,0\ LD A,(pieces)\ LD L,A\ CALL HL_DECI\ ROM_CALL(D_ZM_STR)
 LD HL,$3753\ LD (GRAF_CURS),HL\ LD H,0\ LD A,(level)\ LD L,A\ CALL HL_DECI\ ROM_CALL(D_ZM_STR)


boucle_princ: ;-------------------------------------------------------------------------------------------------------------
 DI
 CALL met_a_jour_l_ecran
 CALL monstres
 EI
 CALL mario_tombe

 ld a,$FF
 out (1),a
 ld a,%10111111
 out (1),a
 in a,(1)
 and %00100000
 call z,saute_princ

 ld a,$FF
 out (1),a
 ld a,$FD
 out (1),a
 in a,(1)
 and %01000000
 jr z,quit_princ

 ld a,$FF
 out (1),a
 ld a,%11111110
 out (1),a
 in a,(1)
 and %00000100
 jr z,droite_princ

 ld a,$FF
 out (1),a
 ld a,%11111110
 out (1),a
 in a,(1)
 and %00000010
 jr z,gauche_princ

 JR boucle_princ

quit_princ:
 SET 7,(IY+$14) ;Ecrit du texte de menu seulement dans la mmoire graphique (GRAPH_MEM) et pas sur l'cran LCD 
 LD HL,PLANE_0              ;
 LD (graysprite_plane_0),HL ;Modifie la routine GRAYSPRITE de SNG
 LD HL,PLANE_1              ;Affiche le sprite dans les buffers buffer_ecr
 LD (graysprite_plane_1),HL ;

 LD A,$2B+1                 ;Modifie la routine de SNG
 LD (grayscale_colonne),A   ;Affiche les 2 dernires colonnes

 call GRAYSCALE_OFF

 JP debut

droite_princ:
 call verifie_collision_droite
 CP 1
 JP Z,boucle_princ
 LD A,(x_mario)
 CP 48
 JR NC,decal_monde
 INC A
 LD (x_mario),A
 JR aff_mario
decal_monde:
 LD A,(buffer8)
 CP 3
 JR NZ,decal_md
 LD A,(num_colonneb-1)
 INC A
 INC A
 LD HL,long_de_la_carte
 CP (HL)
 JR Z,aff_mario0
decal_md:
 call decale_monde
 JR aff_mario
aff_mario0:
 LD A,(x_mario)
 CP 72
 JP Z,charge_niv_suivant
 INC A
 LD (x_mario),A
aff_mario:
 LD A,(sprite_mar_aff)
 CP 0
 JR z,mario_court
 XOR A
 LD (sprite_mar_aff),A
 JP boucle_princ
mario_court:
 INC A
 LD (sprite_mar_aff),A
 JP boucle_princ

gauche_princ:
 call verifie_collision_gauche
 CP 1
 JP Z,boucle_princ
 LD A,(x_mario)
 CP 0
 JP Z,boucle_princ
 DEC A
 LD (x_mario),A

 LD A,(sprite_mar_aff)
 CP 2
 JR z,mario_court2
 LD A,2
 LD (sprite_mar_aff),A
 JP boucle_princ
mario_court2:
 INC A
 LD (sprite_mar_aff),A
 JP boucle_princ

saute_princ:
 LD A,(saut)
 CP 1
 RET Z
 CP 2
 RET Z
 LD A,1
 LD (saut),A
 RET

mario_tombe:
 LD A,(saut)
 CP 0
 JR Z,tombe
 CP 2
 JR Z,empeche_de_sauter
;il faut tester si on peut sauter
 LD A,(y_mario)
 SUB 12
 LD (y_mario),A
 LD A,38
 LD (sprite_collision-1),A
 CALL test_collistion_au_dessus
 LD B,A
 LD A,41
 LD (sprite_collision-1),A
 LD A,(y_mario)
 ADD A,12
 LD (y_mario),A
 LD A,(HL)
 CP 17
 CALL Z,point_interrogation
 CP 18
 CALL Z,point_interrogation
 CP 19
 CALL Z,point_interrogation
 CP 20
 CALL Z,point_interrogation
 LD A,B
 CP 0
 JR Z,saute2
 LD A,2
 LD (saut),A
 RET
saute2:
 LD A,(y_mario)
 DEC A
 DEC A
 LD (y_mario),A
 LD A,(compteur_saut)
 INC A
 LD (compteur_saut),A
 CP 13
 JP C,aff_mario_tombe
 LD A,2
 LD (saut),A
 RET

peut_resauter:
 CALL test_collistion_en_dessous
 CP 1
 JR NZ,saute_pas_encore
 XOR A
 LD (saut),A
 JR tombe
saute_pas_encore:
 LD A,(compteur_saut)
 INC A
 LD (compteur_saut),A
 JR tombe

empeche_de_sauter:
 LD A,(compteur_saut)
 DEC A
 LD (compteur_saut),A
 CP 0
 JR Z,peut_resauter

tombe:
 CALL test_collistion_en_dessous
 CP 1
 RET Z
tombe2:
 LD A,(y_mario)
 INC A
 INC A
 LD (y_mario),A
;mario est il tomb trop bas ?
 CP 52
 JP M,aff_mario_tombe
 JR NC,mario_est_mort_tombe
aff_mario_tombe:
 RET

mario_est_mort_tombe:
 POP HL
 JP mario_est_mort

verifie_collision_droite: ;blocs 1  38: collision ;sortie: A=0 pas de collision, A=1 collision
 LD A,(y_mario)
 ADD A,11
 SRL A;
 SRL A;A=A/8
 SRL A;
 LD H,0
 LD L,A
 LD BC,(long_de_la_carte)
 CALL MUL_HL_BC
 LD BC,CurMap
 ADD HL,BC
 LD A,(buffer8)
 CP 1
 JR Z,buffer_1_c_d
 CP 2
 JR Z,buffer_2_c_d
 CP 3
 JR Z,buffer_3_c_d
;buffer_0_c_d
 LD A,(x_mario)
 ADD A,2
 JR continue_collision_d
buffer_1_c_d:
 LD A,(x_mario)
 ADD A,4
 JR continue_collision_d
buffer_2_c_d:
 LD A,(x_mario)
 ADD A,6
 JR continue_collision_d
buffer_3_c_d:
 LD A,(x_mario)
 ADD A,8
continue_collision_d:
 SRL A;
 SRL A;A=A/8
 SRL A;
 LD B,0
 LD C,A
 ADD HL,BC
 LD A,(num_colonneb-1)
 SUB 8
 LD B,0
 LD C,A
 ADD HL,BC
;HL = adresse du numro du carr sous mario
 LD A,(HL)
 CP 0
 RET Z
 CP 38
num_carre_droite:
 JR C,collistion_droite
 LD A,0
 RET
collistion_droite:
 LD A,1
 RET

verifie_collision_gauche: ;blocs 1  38: collision ;sortie: A=0 pas de collision, A=1 collision
 LD A,(y_mario)
 ADD A,11
 SRL A;
 SRL A;A=A/8
 SRL A;
 LD H,0
 LD L,A
 LD BC,(long_de_la_carte)
 CALL MUL_HL_BC
 LD BC,CurMap
 ADD HL,BC
 LD A,(buffer8)
 CP 1
 JR Z,buffer_1_c_g
 CP 2
 JR Z,buffer_2_c_g
 CP 3
 JR Z,buffer_3_c_g
;buffer_0_c_g
 LD A,(x_mario)
 SUB 7
 JR continue_collision_g
buffer_1_c_g:
 LD A,(x_mario)
 SUB 5
 JR continue_collision_g
buffer_2_c_g:
 LD A,(x_mario)
 SUB 3
 JR continue_collision_g
buffer_3_c_g:
 LD A,(x_mario)
 SUB 1
continue_collision_g:
 SRL A;
 SRL A;A=A/8
 SRL A;
 LD B,0
 LD C,A
 ADD HL,BC
 LD A,(num_colonneb-1)
 SUB 8
 LD B,0
 LD C,A
 ADD HL,BC
;HL = adresse du numro du carr sous mario
 LD A,(HL)
 CP 0
 RET Z
 CP 38
num_carre_gauche:
 JR C,collistion_gauche
 LD A,0
 RET
collistion_gauche:
 LD A,1
 RET

test_collistion_au_dessus: ;si c'est le cas, A=1 sinon A=0
 XOR A
 LD (test),A
 JR test_du_cote_droit2
test_du_cote_gauche2:
 LD A,1
 LD (test),A
 LD A,(x_mario)
 ADD A,7
 LD (x_mario),A
test_du_cote_droit2:
 LD A,(y_mario)
 ADD A,12
 SRL A;
 SRL A;A=A/8
 SRL A;
 JR test_en_haut_et_en_bas

test_collistion_en_dessous: ;si c'est le cas, A=1 sinon A=0
 XOR A
 LD (test),A
 JR test_du_cote_droit
test_du_cote_gauche:
 LD A,1
 LD (test),A
 LD A,(x_mario)
 ADD A,7
 LD (x_mario),A
test_du_cote_droit:

 LD A,(y_mario)
 ADD A,12
 SRL A;
 JP C,pas_de_collision
 SRL A;A=A/8
 JP C,pas_de_collision
 SRL A;
 JP C,pas_de_collision
test_en_haut_et_en_bas:
 LD H,0
 LD L,A
 LD BC,(long_de_la_carte)
 CALL MUL_HL_BC
 LD BC,CurMap
 ADD HL,BC
 LD A,(sprite_mar_aff)
 CP 2
 JR NC,test_coll_gauche
;test_coll_droite
 LD A,(buffer8)
 CP 1
 JR Z,buffer_1_c_db
 CP 2
 JR Z,buffer_2_c_db
 CP 3
 JR Z,buffer_3_c_db
;buffer_0_c_db
 LD A,(x_mario)
 SUB 6
 JR continue_collision_db
buffer_1_c_db:
 LD A,(x_mario)
 SUB 4
 JR continue_collision_db
buffer_2_c_db:
 LD A,(x_mario)
 SUB 2
 JR continue_collision_db
buffer_3_c_db:
 LD A,(x_mario)
continue_collision_db:
 JR fin_test_coll
test_coll_gauche:
 LD A,(buffer8)
 CP 1
 JR Z,buffer_1_c_gb
 CP 2
 JR Z,buffer_2_c_gb
 CP 3
 JR Z,buffer_3_c_gb
;buffer_0_c_gb
 LD A,(x_mario)
 SUB 7
 JR continue_collision_gb
buffer_1_c_gb:
 LD A,(x_mario)
 SUB 5
 JR continue_collision_gb
buffer_2_c_gb:
 LD A,(x_mario)
 SUB 3
 JR continue_collision_gb
buffer_3_c_gb:
 LD A,(x_mario)
 SUB 1
continue_collision_gb:
fin_test_coll:
 SRL A;
 SRL A;A=A/8
 SRL A;
 LD B,0
 LD C,A
 ADD HL,BC
 LD A,(num_colonneb-1)
 SUB 8
 LD B,0
 LD C,A
 ADD HL,BC
;HL = adresse du numro du carr sous mario
 LD A,(HL)
 CP 0
 JR Z,pas_de_collision
 CP 41
sprite_collision:
 JR NC,pas_de_collision
 LD A,(test)
 CP 0
 JR Z,a_egu_1
 LD A,(x_mario)
 SUB 7
 LD (x_mario),A
a_egu_1:
 LD A,1
 RET
pas_de_collision:
 LD A,(test)
 OR A
 JP Z,test_du_cote_gauche
 LD A,(x_mario)
 SUB 7
 LD (x_mario),A
 LD A,0
 RET

point_interrogation:
 PUSH BC
 PUSH AF
 PUSH HL
 LD (HL),2 ;on remplace le point d'interrogation en bloc
;remplace le sprite du point d'interrogation par un bloc
 LD A,(test)
 OR A
 JR Z,collision_cote_gauche
 LD A,(x_mario)
 ADD A,7
 JR fin_collision_cote
collision_cote_gauche:
 LD A,(buffer8)
 CP 3
 JR NZ,p_mario_est_pile_dessous
 LD A,(x_mario)
 JR fin_collision_cote
p_mario_est_pile_dessous:
 LD A,(x_mario)
 SUB 7
fin_collision_cote:
 CALL dec_jusqu_a_mul_8
 PUSH AF
 LD A,(buffer8)
 CP 0
 JR Z,decale0
 CP 1
 JR Z,decale1
 CP 2
 JR Z,decale2
;decale_pas
 POP AF
 JR fini_decale
decale0:
 POP AF
 ADD A,6
 JR fini_decale
decale1:
 POP AF
 ADD A,4
 JR fini_decale
decale2:
 POP AF
 ADD A,2
fini_decale:
 LD B,A
 LD A,(y_mario)
 CALL dec_jusqu_a_mul_8
 LD C,A
 LD DE,s02
;modifie la routine de sprite pour qu'elle efface ce qu'il y a sous le sprite au lieu de superposer
 LD A,8
 CALL GRAYSPRITE ;b = x,c = y,de = adresse du sprite,A = taille du sprite (nombre de lignes)
 POP HL
 POP AF
 CP 17
 JR Z,pt_interro_piece
 CP 18
 JR Z,pt_interro_champignon

pt_interro_piece:
 LD A,(pieces)
 INC A
 CP 100            ;au bout de 100 pices, on ajoute une vie et on remet les pices  0
 JR NZ,p_nouv_vie
 XOR A
 LD A,(vies)
 INC A
 LD (vies),A
p_nouv_vie:
 LD (pieces),A
 LD HL,$2053\ LD (GRAF_CURS),HL\ LD H,0\ LD A,(pieces)\ LD L,A\ CALL HL_DECI\ ROM_CALL(D_ZM_STR)
 POP BC
 RET
pt_interro_champignon:
;mario est-il dja grand?
 LD A,(mario_transformation)
 OR A
 JR Z,mario_est_petit
;ici soit mario est grand, soit il a le pouvoir de la fleur
;de toute facon a revient au mme on met une fleur
 LD HL,ennemis_affiches
 LD DE,7
 ADD HL,DE
 CALL insere_ennemis
 LD (HL),19
 INC HL
 LD (HL),1
 INC HL
 LD (HL),-10
 INC HL
 LD A,(y_mario)
 CALL dec_jusqu_a_mul_8
 SUB 8
 LD (HL),A
 INC HL
 PUSH HL
 LD A,(x_mario)
 SRL A\ SRL A\ SRL A
 LD HL,num_colonneb-1
 ADD A,(HL)
 SUB 9
 POP HL
 LD (HL),A
 INC HL
 LD A,(y_mario)
 SRL A\ SRL A\ SRL A
 LD (HL),A
 INC HL
 LD (HL),0
 LD DE,7
 LD HL,(pointeur_ennemis_affiches)
 ADD HL,DE
 LD (pointeur_ennemis_affiches),HL
 POP BC
 RET
mario_est_petit:
;on met un champignon
 LD HL,ennemis_affiches
 LD DE,7
 ADD HL,DE
 CALL insere_ennemis
 LD (HL),16
 INC HL
 LD (HL),1
 INC HL
 LD (HL),-10
 INC HL
 LD A,(y_mario)
 CALL dec_jusqu_a_mul_8
 SUB 8
 LD (HL),A
 INC HL
 PUSH HL
 LD A,(x_mario)
 SRL A\ SRL A\ SRL A
 LD HL,num_colonneb-1
 ADD A,(HL)
 SUB 9
 POP HL
 LD (HL),A
 INC HL
 LD A,(y_mario)
 SRL A\ SRL A\ SRL A
 LD (HL),A
 INC HL
 LD (HL),0
 LD DE,7
 LD HL,(pointeur_ennemis_affiches)
 ADD HL,DE
 LD (pointeur_ennemis_affiches),HL
 POP BC
 RET

dec_jusqu_a_mul_8:
 SRL A
 SRL A
 SRL A
 ADD A,A
 ADD A,A
 ADD A,A
 RET

mario_est_mort:
 LD a,(mario_transformation)
 OR A
 JR NZ,mario_mort
 DEC A
 LD (mario_transformation),A
 JP boucle_princ
mario_mort:
 CALL GRAYSCALE_OFF
 JP prepare_monde2

charge_niv_suivant:
 LD A,(level)
 INC A
 LD (level),A
 CALL GRAYSCALE_OFF
 JP prepare_monde2

;Chaines de caracteres
jouer .DB "jouer",0
A_propos .DB "A propos",0
Quitter .DB "Quitter",0
apropos_ch .DB "Mario SNG v0.1  "
           .DB "      par       "
           .DB " Marc Plouhinec "
           .DB "   01-09-2003",0
apropos_ch2 .DB "http://www.thebestof.tk",0
choisissez_niv .DB "               Choisissez un "
               .DB "niveau                ",0

;variables
sprite_champignon .DB 0
nombre_de_niveaux .DB 0
niveau_choisi .DB 0
adresse_du_niveau .DW 0
forvarx .DB 0
forvary .DB 0
x_mario .DB 0
y_mario .DB 0
saut .DB 0
compteur_saut .DB 0
sprite_mar_aff .DB 0
test .DB 0
pointeur_ennemis_affiches .DW 0
mario_transformation .DB 0
vies .DB 0
pieces .DB 0
buffer8 .DB 0
buffer8_2 .DB 0
buffer16 .DW 0
buffer16_2 .DW 0

#include "charge_n.inc"
#include "affich_n.inc"
#include "monstres.inc"
#include "titre.inc"
#include "sprite.inc"
#include "menug.inc"
#include "mariosp.inc"

buffer_ecr:
buffer_ecr_PLANE_0:
.ds 768
buffer_ecr_PLANE_1:
.ds 768
ennemis_affiches:
 .ds 225   ;32 enemies
           ;7 bytes each
       			;1 = type
			;2 = direction
			;3 = x
			;4 = y
			;5 = init x
			;6 = init y
			;7 = timer
 .ds 7
.end
END