;adresse_du_niveau = adresse du monde (octet juste aprs le mot de passe)

CurEnemyTable:  .ds $300; = APD_BUF  ;no more than 100 entries
  ;entry byte #1 = type of enemy
  ;entry byte #2 = column location
  ;entry byte #3 = Y coord

CurMap:
 .ds 1024

long_de_la_carte .DW 0
ypos .DW 0
xpos .DW 0
cursor .DW 0
map_offset .DW 0
level .DW 0

oldsize .DW 0
;------------------------------------------------------------------------------------------
Charge_niv:
 call InitMap
 call LoadLOffset
 push hl
 ld c,(hl)
 inc hl
 ld b,(hl)  ;BC = # of bytes to Decompress

 push bc
 push hl

 ld h,b
 ld l,c
 ld a,8
 call $00A3
 ld a,l
 ld (long_de_la_carte),a
 pop hl
 pop bc

 inc hl
 ld e,(hl)
 inc hl
 ld d,(hl)  ;DE = # of bytes when Compressed
 inc hl
 ld (oldsize),de

 push de
        ;bc = # of bytes to decompress
        ;hl now points to data to decompress
 ld de,CurMap
 call Decompress
 pop de
 pop hl
 add hl,de       ;now point to enemy_table
 inc hl
 inc hl
 inc hl
 inc hl

 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl     ;now points to data

 push de

 ld de,CurEnemyTable
 ld bc,300           ;always 300
 call Decompress
 pop de
 ld hl,(oldsize)
 add hl,de
 ld (oldsize),hl  ;oldsize = data + table (compressed)
 ret

;------------------------------------------------------------------------------------------

InitMap:
 call _grbufclr
 ld hl,CurEnemyTable
 ld bc,299
 call OTH_CLEAR

 ld hl,CurMap
 ld bc,1023
 call OTH_CLEAR

 ld a,10
 ld (long_de_la_carte),a

 xor a
 ld (xpos),a
 ld (ypos),a
 ld (map_offset),a
 inc a
 ld (cursor),a
 ret

;------------------------------------------------------------------------------------------

_grbufclr:
 ld hl,GRAPH_MEM
 ld bc,767
OTH_CLEAR:
 ld e,l
 ld d,h
 inc de
 ld (hl),0
 ldir
 ret

;------------------------------------------------------------------------------------------

LoadLOffset:
 ld hl,(adresse_du_niveau)  ;points to external data
 inc hl  ;skip # of levels
 ld a,(level)
 dec a
 add a,a 
 ld e,a
 ld d,0
 add hl,de  ;find offset value
 ld e,(hl)
 inc hl
 ld d,(hl)      ;de = offset from MapLoc+51

 ld hl,(adresse_du_niveau)
 ld bc,51
 add hl,bc
 add hl,de  ;now points to level data
 ret

;------------------------------------------------------------------------------------------

Decompress:
    ld a, (hl)          ; get the next byte
    sub $80             ; is it a run?
    jr nc, DispRLERun   ; then we need to decode the run
    ldi                 ; copy the byte, and update counters
DispRLEC:
    ld a,b
	or c
	ret z               ; ret if bc hit 0
    jr Decompress       ; otherwise do next byte
DispRLERun:
    ld (hl),a ;make this the copy byte
    inc hl              ; move to the run count
    ld a,(hl)           ; get the run count
DispRLERunL:
    dec hl              ; go back to run value
    ldi                 ; copy byte, dec bc, inc de, inc hl
    dec a               ; decrease run counter
    jr nz, DispRLERunL  ; if we're not done, then loop
    dec hl
    ld a,(hl)
    add a,$80
    ld (hl),a
    inc hl
    inc hl              ; advance the source pointer
    jr DispRLEC         ; check to see if we should loop

;------------------------------------------------------------------------------------------
CurEnemyTable_temp = PLANE_0
range_CurEnemyTable:
 LD HL,CurEnemyTable
 LD DE,CurEnemyTable_temp
 LD BC,300
 LDIR
 LD HL,CurEnemyTable
 LD DE,CurEnemyTable+1
 LD BC,300
 LD (HL),0
 LDIR
 LD DE,CurEnemyTable
 LD C,1
teste_une_nouv_colonne:
 LD HL,CurEnemyTable_temp+1
 LD B,100
classe_ennemis_par_colonne:
 LD A,(HL)
 CP C
 CALL Z,copie_ennemis
 INC HL\ INC HL\ INC HL
 DJNZ classe_ennemis_par_colonne
 INC C
 LD A,C
 LD HL,long_de_la_carte
 CP (HL)
 JR C,teste_une_nouv_colonne
 RET

copie_ennemis:
 DEC HL
 PUSH BC
 LD BC,3
 LDIR
 POP BC
 INC HL
 RET
.end