;entree
;------
;BC = taille de l'image
;HL = source
;DE = buffer
;2 premiers octets de buffer = taille du buffer
;sortie
;------
;(buffer) = taille de l'image compresse
;(buffer+2) = image compresse
;
;Algorithme:
;-----------
;il est enregistr  la suite le nombre de pixels de mme couleur.
;le premier octet est gal  1 (resp. 0) si l'image commence par du noir (resp. blanc).
;0 = "1 pixel" , ... , 254 = "255 pixels" , 255 = "255 pixels attention: les pixels suivant sont de la mme couleur".
;
Compression_RLE_bit_par_bit: ;Routine par Marc Plouhinec 12-04-2003
 LD (adresse_du_buffer),DE   ;(adresse_du_buffer) = adresse du buffer
 PUSH BC                     ;
 PUSH HL                     ;
 PUSH DE                     ;
 EX DE,HL                    ;-
 LD E,(HL)                   ; |
 INC HL                      ; |(taille_max) = taille du buffer
 LD D,(HL)                   ; |
 LD (taille_max),DE          ;-
 POP DE                      ;
 INC DE                      ;
 INC DE                      ;
 PUSH DE                     ; DE = buffer+2
 LD A,0                      ;
 LD (compteur_compr),A       ;(compteur_compr) = 0
 LD HL,0                     ;
 LD (taille_du_buffer),HL    ;(taille_du_buffer) = 0

 POP DE                      ;--place le premier octet dfinissant la premire couleur
 POP HL                      ;
 LD A,(HL)                   ;
 ADD A,A                     ; C <- |7<-------0| <- 0
 jr c,premier_pixel_noir     ;
;premier_pixel_blanc         ;
 LD A,0                      ;
 LD (blanc_ou_noir),A        ;
 LD (DE),A                   ;
 INC DE                      ;
 JR continue_1_compr         ;
premier_pixel_noir:          ;
 LD A,1                      ;
 LD (blanc_ou_noir),A        ;
 LD (DE),A                   ;
 INC DE                      ;
continue_1_compr:            ; (blanc_ou_noir) = 0 ou 1
 PUSH HL                     ; HL = source
 PUSH DE                     ; DE = buffer+3

compresse_vraiment:
 POP DE                      ;
 POP HL                      ;
 LD A,(HL)                   ;
 INC HL                      ;
 PUSH HL                     ;
 PUSH DE                     ;
 LD (petit_buffer),A         ;
 LD B,8                      ;
compte_pixel_dans_un_bit:    ;
 LD A,(petit_buffer)         ;
 ADD A,A                     ; C <- |7<-------0| <- 0
 LD (petit_buffer),A         ;
 JR C,pixel_noir             ;
;pixel_blanc                 ;
 LD A,(blanc_ou_noir)        ;
 OR A                        ; CP 0
 CALL NZ,changement_de_couleur
 CALL inc_compteur_compr     ;
 JR continue_2_compr         ;
pixel_noir:                  ;
 LD A,(blanc_ou_noir)        ;
 OR A                        ; CP 0
 CALL Z,changement_de_couleur;
 CALL inc_compteur_compr     ;
continue_2_compr:
 DJNZ compte_pixel_dans_un_bit

 POP DE                      ;
 POP HL                      ;
 POP BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 DEC BC                      ;
 PUSH BC                     ;
 PUSH HL                     ;
 PUSH DE                     ;

 LD HL,0                     ;
 CP_HL_BC                    ;
 JR NZ,compresse_vraiment    ;
 POP DE                      ;
 POP HL                      ;
 POP BC                      ;

 LD HL,(adresse_du_buffer)   ;
 LD DE,(taille_du_buffer)    ;
 LD (HL),E                   ;
 INC HL                      ;
 LD (HL),D                   ;
 RET                         ;

changement_de_couleur:
 POP BC ;attention: cette routine est issue d'un appel, ici BC = adresse du programme execut aprs le RET
 LD DE,(taille_du_buffer)    ;
 LD HL,(taille_max)          ;
 CALL CP_HL_DE               ;
 JR Z,buffer_plein           ;
 POP DE                      ;
 LD HL,(taille_du_buffer)    ;
 INC HL                      ;
 LD (taille_du_buffer),HL    ;
 LD A,(compteur_compr)       ;
 LD (DE),A                   ;
 INC DE                      ;
 LD A,0                      ;
 LD (compteur_compr),A       ;
 PUSH DE                     ;
 PUSH BC                     ;
 RET                         ;
buffer_plein:
 LD A,0                      ;
 LD (compteur_compr),A       ;
 PUSH BC                     ;
 RET                         ;

inc_compteur_compr:
 LD A,(compteur_compr)       ;
 INC A                       ;
 LD (compteur_compr),A       ;
 CP 255                      ;
 JR Z,inc_compteur_compr_2   ;
 RET                         ;
inc_compteur_compr_2:        ;
 CALL changement_de_couleur  ;
 RET                         ;

adresse_du_buffer .DW 0
blanc_ou_noir .DB 0
compteur_compr .DB 0
taille_du_buffer .DW 0
taille_max .DW 0
petit_buffer .DB 0


;entree
;------
;HL = image compresse
;DE = buffer de 768 octets o l'image sera compresse
;sortie
;------
;(buffer) = image dcompresse
;
Decompression_RLE_bit_par_bit: ;Routine par Marc Plouhinec 12-04-2003
 PUSH DE
 LD E,(HL)
 INC HL
 LD D,(HL)
 LD (taille_de_l_image_compr),DE
 INC HL
 POP DE

;DE = buffer
;HL = image+2

 LD C,(HL) ; C = "0=blanc" ou "1=noir"
 INC HL
 LD A,0
 LD (encore_de_la_meme_couleur),A
 LD A,8
 LD (octet_a_sauver),A

continue_decompr:
 LD A,(HL)
 LD (compteur_decompr),A
 INC HL
 CP 255
 JR NZ,p_meme_couleur_apres
 LD A,1
 LD (encore_de_la_meme_couleur),A
 JR affiche_pixels
p_meme_couleur_apres:
 INC A
 LD (compteur_decompr),A
 LD A,0
 LD (encore_de_la_meme_couleur),A


affiche_pixels:
 LD A,0
 LD B,(octet_a_sauver)
affiche_pixels2:
 ADD A,A
 ADD C
 DJNZ affiche_pixels2
 LD (DE),A
 INC DE

 LD A,(compteur_decompr)
 SUB 8
 LD (compteur_decompr),A
 OR 0
 JR NZ,affiche_pixels

 PUSH HL
 PUSH DE
 LD HL,(taille_de_l_image_deja_decompresse)
 INC HL
 LD (taille_de_l_image_deja_decompresse),HL
 LD DE,(taille_de_l_image_compr)
 CALL CP_HL_DE
 JR Z,fin_de_la_decompression
 POP DE
 POP HL
 LD A,(encore_de_la_meme_couleur)
 CP 1
 JR Z,continue_decompr
 LD A,C
 OR 0
 JR Z,maintenant_on_passe_au_blanc

fin_de_la_decompression:
 POP DE
 POP HL

 RET

taille_de_l_image_compr .DW 0
taille_de_l_image_deja_decompresse .DW 0
encore_de_la_meme_couleur .DB 0
compteur_decompr .DB 0
octet_a_sauver .DB 0






























Compress: ;routine par Sam Heald
   push ix 
   call RLEcompL 
   pop de 
   push ix 
   pop hl 
   sbc hl, de 
   ret

RLEcompL: 
   ld a, (hl) 
   inc hl 
   cp (hl) 
   jr nz, ContRLEcomp2 
RLEcomp_StoType:
   push af
   add a,$80
   ld (ix),a ;set the byte
   pop af
   inc ix
   ld e,1 
RLEcompRunL: 
   CPI 
   jp po, End_RLEcompRunL 
   jr nz, End_RLEcompRunL 
   inc e 
   jr nz,RLEcompRunL 
   jr ContRLEcomp 
End_RLEcompRunL: 
   inc bc 
   dec hl 
ContRLEcomp: 
   ld a,e
ContRLEcomp2:
   ld (ix),a 
   dec bc 
   ld a,b 
   or c 
   inc ix 
   ret z 
   jr RLEcompL

;HL = adresse du premier octet
;BC = # of bytes to Decompress
Decompress: ;routine par Sam Heald
    ld a, (hl)          ; get the next byte
    sub $80             ; is it a run?
    jr nc, DispRLERun   ; then we need to decode the run
    ldi                 ; copy the byte, and update counters
DispRLEC:
    ld a,b
	or c
	ret z               ; ret if bc hit 0
    jr Decompress       ; otherwise do next byte
DispRLERun:
    ld (hl),a ;make this the copy byte
    inc hl              ; move to the run count
    ld a,(hl)           ; get the run count
DispRLERunL:
    dec hl              ; go back to run value
    ldi                 ; copy byte, dec bc, inc de, inc hl
    dec a               ; decrease run counter
    jr nz, DispRLERunL  ; if we're not done, then loop
    dec hl
    ld a,(hl)
    add a,$80
    ld (hl),a
    inc hl
    inc hl              ; advance the source pointer
    jr DispRLEC         ; check to see if we should loop
.end